/*
 * Rs[^bK 2-12: PGM`̉摜t@C̃XP[ϊ
 * 2005N613  @
 * 2004N6 8 J ۔
 *
 * PGM`̉摜t@C摜f[^ǂݍ݁CL[{[h{
 * ǂݍ݁CXP[ϊāCPGM`̉摜t@C֏oD
 * ϊ̉摜f[^̑傫ω邱ƂɒӁD
 */

#include <stdio.h>

#define MAXHEIGHT       512     /* 摜f[^z̍ */
#define MAXWIDTH        512     /* 摜f[^z̕ */
#define MAXVALUE        255     /* Pxl̍ől */
#define NCOL            17      /* 1sɏo͂鐔l̐ */
#define BSIZE           80      /* pz̑傫 */

/* O̊֐̃vg^Cv錾 */
int    scale(unsigned char g[][MAXWIDTH], int h, int w, double m,
	     unsigned char g2[][MAXWIDTH], int *ph2, int *pw2);
double scanDouble(char prompt[]);
FILE  *openFile(char prompt[], char mode[]);
int    readPGM(FILE *fp, unsigned char g[][MAXWIDTH], int *ph, int *pw);
int    skipComment(FILE *fp);
int    writePGM(FILE *fp, unsigned char g[][MAXWIDTH], int h, int w);

int
main(void)
{
    FILE                 *fp;
    static unsigned char image[MAXHEIGHT][MAXWIDTH];
    static unsigned char image2[MAXHEIGHT][MAXWIDTH];
    int                  height, width, height2, width2;
    double               mag;
        
    /**** ̓t@C̃I[v ***/
    fp = openFile("̓t@C  ", "r");

    /*** ǂݍ ***/
    if( readPGM(fp, image, &height, &width) ) {
        printf("ǂݍ݂Ɏs܂DvOI܂D\n");
        return 1;
    }

    fclose(fp);
    
    /*** p[^̓ǂݍ ***/
    mag = scanDouble("{            ");
    
    /*** XP[ϊ ***/
    if( scale(image, height, width, mag, image2, &height2, &width2) ){
        printf("ϊɎs܂DvOI܂D\n");
        return 1;
    }

    /*** o̓t@C̃I[v ***/
    fp = openFile("o̓t@C  ", "w");

    /*** o ***/
    if ( writePGM(fp, image2, height2, width2) ) {
        printf("oɎs܂DvOI܂D\n");
        return 1;
    }

    fclose(fp);
    
    return 0;
}

/*
 * 摜f[^c{ŊgEkD
 * ϊ̉摜̉fPʂŏsȂD
 * g            ͉摜f[^i[Ă2z
 * h            ͉摜f[^̍
 * w            ͉摜f[^̕
 * s            { (s>1:gCs<1:k)
 * g2           o͉摜f[^i[2z
 * ph2          o͉摜f[^̍̊i[ꏊw|C^
 * pw2          o͉摜f[^̊̕i[ꏊw|C^
 * ߂l       I0Cf[^Ɉُ킪ꍇ1
 */
int
scale(unsigned char g[][MAXWIDTH], int h, int w, double m,
      unsigned char g2[][MAXWIDTH], int *ph2, int *pw2)
{
    int         i, j, i2, j2;

    if ( m <= 0 ) {
        fprintf(stderr,
                "{%fsK؂łD\n", m);
        return 1;
    }
    
    /* ϊ̗̈̑傫߂ */
    *pw2 = w*m;
    if ( *pw2 > MAXWIDTH ) {
        fprintf(stderr,
                "ϊ̕%d%dzĂ܂D\n", *pw2, MAXWIDTH);
        return 1;
    }

    *ph2 = h*m;
    if ( *ph2 > MAXHEIGHT ) {
        fprintf(stderr,
                "ϊ̍%d%dzĂ܂D\n", *ph2, MAXHEIGHT);
        return 1;
    }
        
    for ( i2 = 0; i2 < *ph2; i2++ ) {
        i = i2/m;
        for ( j2 = 0; j2 < *pw2; j2++ ) {
            j = j2/m;
            g2[i2][j2] = g[i][j];
        }
    }

    return 0;
}


/*
 * L[{[hlǂݍ
 * {͓͂ꂽ񂪐lƂĐCl͈̔͂K𔻒fC
 *   sK؂ȏꍇɑΏׂD
 *
 * :   prompt ͂𑣂ۂɕ\镶
 * ߂l         ǂݍ񂾐lD
 */
double
scanDouble(char prompt[])
{
    double       r;
    
    printf(prompt);
    scanf("%lf", &r);

    return r;
}


/*
 * t@C̓͂ƃt@C̃I[v
 * {̓I[vłȂꍇ̑ΏƒJɂׂD
 *
 *    prompt: ͂𑣂ۂɕ\镶
 *        mode:   fopen()Ɏg[h̕
 * ߂l         I[vt@C̃t@C|C^
 */
FILE *
openFile(char prompt[], char mode[])
{
    FILE *fp;
    char filename[BSIZE];
    
    printf(prompt);
    scanf("%s", filename);

    fp = fopen(filename, mode);
    if ( fp == NULL ) {
        printf("t@C%sI[vł܂DI܂D\n", filename);
	exit(1);
    }

    return fp;
}

/*
 * w̓̓Xg[PGM`̉摜f[^ǂݍށD
 * fp           ̓Xg[w|C^
 * g            摜f[^i[2z
 * ph           摜f[^̍̊i[ꏊw|C^
 * pw           摜f[^̊̕i[ꏊw|C^
 * ߂l       I0Cf[^Ɉُ킪ꍇ1
 */
int
readPGM(FILE *fp, unsigned char g[][MAXWIDTH], int *ph, int *pw)
{
    int         i, j, v, m;
    
    if ( fgetc(fp) != 'P' || fgetc(fp) != '2' ) {
        printf( "̃f[^PGM`ł͂܂D\n");
        return 1;
    }

    skipComment(fp);
    if ( fscanf(fp, "%d", pw) != 1 ) {
        printf( "̓ǂݍ݂Ɏs܂D\n");
        return 1;
    }
    if ( *pw > MAXWIDTH ) {
        printf("(%d)%dzĂ܂D\n", *pw, MAXWIDTH);
        return 1;
    }
    
    skipComment(fp);
    if ( fscanf(fp, "%d", ph) != 1 ) {
        printf("̓ǂݍ݂Ɏs܂D\n");
        return 1;
    }
    if ( *ph > MAXHEIGHT ) {
        printf("(%d)%dzĂ܂D\n", *ph, MAXHEIGHT);
        return 1;
    }

    skipComment(fp);
    if ( fscanf(fp, "%d", &m) != 1 ) {
        printf( "őPxl̓ǂݍ݂Ɏs܂D\n");
        return 1;
    }
    if ( m != MAXVALUE ) {
        printf("őPxl(%d)%dł͂܂D\n", m, MAXVALUE);
        return 1;
    }

    skipComment(fp);
    for ( i = 0; i < *ph; i++ ) {
        for ( j = 0; j < *pw; j++ ) {
            if ( fscanf(fp, "%d", &v) != 1 ) {
                printf("vf(%d, %d)ǂݍ߂܂łD\n", i, j);
                return 1;
            }
            if ( v < 0 || v > MAXVALUE ) {
                printf("vf(%d, %d)̋Pxl%d͈͂zĂ܂D\n",
                        i, j, v);
                return 1;
            }
            g[i][j] = v;
        }
    }
                
    return 0;
}


/*
 * w肳ꂽ̓Xg[PGM`̒̒('#'s܂)ǂݔ΂
 * fp           ̓Xg[w|C^
 * ߂l       I0C͏I -1
 */
int
skipComment(FILE *fp)
{
    int         r;
    char        s[2];

    while ( 1 ) {
        /* 󔒁E^uEsǂݔ΂ */
        /* ̒*͑}̖Dcf. scanf()̃}jA */
        fscanf(fp, "%*[ \t\n]"); 

        /* #ȂΏI */
       if ( (r = fscanf(fp, "%1[#]", s)) != 1 ) break;

       /* #Ήs̎O(̍s̖)܂œǂݔ΂ */
       fscanf(fp, "%*[^\n]");
    }

    return r;
}


/*
 * w肳ꂽo̓Xg[PGM`̉摜f[^oD
 * fp           o̓Xg[w|C^
 * g            摜f[^i[2z
 * h            摜f[^̍
 * w            摜f[^̕
 * ߂l       I0Cf[^Ɉُ킪ꍇ1
 */
int
writePGM(FILE *fp, unsigned char g[][MAXWIDTH], int h, int w)
{
    int         i, j, k, v;

    fprintf(fp, "P2\n");

    if ( w > MAXWIDTH ) {
        printf("(%d)%dzĂ܂D\n", w, MAXWIDTH);
        return 1;
    }
    fprintf(fp, "%d", w);
    
    if ( h > MAXHEIGHT ) {
        printf("(%d)%dzĂ܂D\n", h, MAXHEIGHT);
        return 1;
    }
    fprintf(fp, " %d\n", h);

    fprintf(fp, "%d\n", MAXVALUE);

    k = 0;
    for ( i = 0; i < h; i++ ) {
        for ( j = 0; j < w; j++ ) {
            v = g[i][j];
            if ( v < 0 || v > MAXVALUE ) {
                printf("vf(%d, %d)̋Pxl%d͈͂zĂ܂D\n",
                        i, j, v);
                return 1;
            }
            fprintf(fp, "%3d ", v);
            /* NCOLɉs} (1s70ȓƂKi邽) */
            if ( (k+1)%NCOL == 0 ) {
                fprintf(fp, "\n");
            }
            k++;
        }
    }
                
    return 0;
}
